#include "glWindow.h"

int main( int argc, char *argv[] )
{
   HAB   hab = NULLHANDLE;
   HMQ   hmq = NULLHANDLE;
   HWND  hwndFrame = NULLHANDLE;
   HWND hwndClient;
   ULONG flCreate = 0UL;
   QMSG  qmsg;
   int retVal = 1;

   do
   {
      /* Initialize PM and create a message queue of default size */
      if( ( hab = WinInitialize( 0UL ) ) == NULLHANDLE )
         break;

      if( ( hmq = WinCreateMsgQueue( hab, 0UL ) ) == NULLHANDLE )
         break;

      /* Register client window class */
      if( !WinRegisterClass( hab,  "PGL_Demo", ClientWindowProc,
                                         CS_SIZEREDRAW, 0L ) )
          break;

      /* Create the windows  */
      flCreate = FCF_STANDARD & ~(FCF_ICON | FCF_MENU | FCF_ACCELTABLE);

      hwndFrame = WinCreateStdWindow( HWND_DESKTOP, WS_VISIBLE,  &flCreate,
                    "PGL_Demo",  "OpenGL Demonstration 11 - pm" ,
                    CS_SIZEREDRAW, 0L, 0x1000, &hwndClient );

      if( hwndFrame == NULLHANDLE )
         break;

      /* window created, initialize opengl */
      initOpenGL( hwndClient );

      /* set the window position */
      WinSetWindowPos( hwndFrame, HWND_TOP, 0, 0, 400, 400, SWP_ACTIVATE | SWP_SIZE | SWP_SHOW );

      /* Message loop */
      while( WinGetMsg( hab, &qmsg, 0L, 0L, 0L ) )
         WinDispatchMsg( hab, &qmsg );

      retVal = 0;
   } while( FALSE );

   /* cleanup */

   cleanupOpenGL( hwndClient );

   if ( hwndFrame != NULLHANDLE )
      WinDestroyWindow( hwndFrame );

   /* Destroy the message queue and release the anchor block */
   if ( hmq != NULLHANDLE )
      WinDestroyMsgQueue( hmq );

   if ( hab != NULLHANDLE )
      WinTerminate( hab );

   return( retVal );
}
